module ElmskellTypes.Generated.Decoder exposing (..)

import Iso8601 as Iso
import Json.Decode as D exposing (..)
import Json.Decode.Pipeline as D exposing (required)

import ElmskellTypes.Generated.ElmStreet exposing (..)
import ElmskellTypes.Generated.Types as T


decodeCommand : Decoder T.Command
decodeCommand = elmStreetDecodeEnum T.readCommand

decodeCookiesKept : Decoder T.CookiesKept
decodeCookiesKept = D.succeed T.CookiesKept
    |> required "keepFont" D.bool
    |> required "keepPrompt" D.bool
    |> required "keepTheme" D.bool

decodeCoreColor : Decoder T.CoreColor
decodeCoreColor = elmStreetDecodeEnum T.readCoreColor

decodeFont : Decoder T.Font
decodeFont = D.succeed T.Font
    |> required "fontSize" D.float

decodeInput : Decoder T.Input
decodeInput = D.succeed T.Input
    |> required "command" decodeCommand
    |> required "args" (D.list D.string)

decodePrompt : Decoder T.Prompt
decodePrompt = D.succeed T.Prompt
    |> required "prompt" D.string

decodeTheme : Decoder T.Theme
decodeTheme = elmStreetDecodeEnum T.readTheme

decodeThemeColor : Decoder T.ThemeColor
decodeThemeColor = elmStreetDecodeEnum T.readThemeColor
