module ElmskellTypes.Generated.Encoder exposing (..)

import Iso8601 as Iso
import Json.Encode as E exposing (..)

import ElmskellTypes.Generated.ElmStreet exposing (..)
import ElmskellTypes.Generated.Types as T


encodeCommand : T.Command -> Value
encodeCommand = E.string << T.showCommand

encodeCookiesKept : T.CookiesKept -> Value
encodeCookiesKept x = E.object
    [ ("tag", E.string "CookiesKept")
    , ("keepFont", E.bool x.keepFont)
    , ("keepPrompt", E.bool x.keepPrompt)
    , ("keepTheme", E.bool x.keepTheme)
    ]

encodeCoreColor : T.CoreColor -> Value
encodeCoreColor = E.string << T.showCoreColor

encodeFont : T.Font -> Value
encodeFont x = E.object
    [ ("tag", E.string "Font")
    , ("fontSize", E.float x.fontSize)
    ]

encodeInput : T.Input -> Value
encodeInput x = E.object
    [ ("tag", E.string "Input")
    , ("command", encodeCommand x.command)
    , ("args", (E.list E.string) x.args)
    ]

encodePrompt : T.Prompt -> Value
encodePrompt x = E.object
    [ ("tag", E.string "Prompt")
    , ("prompt", E.string x.prompt)
    ]

encodeTheme : T.Theme -> Value
encodeTheme = E.string << T.showTheme

encodeThemeColor : T.ThemeColor -> Value
encodeThemeColor = E.string << T.showThemeColor
